﻿using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FeatureGuideCharp
{
    class UseTemplateToCreateNewPackage
    {


        //role1 ID: 1UvKGUIhPxwG(sender)
        //role2 ID: 9624914d-64f0-44a3-975b-89cb4a3c9073(signer)
        //document names for the new package: doc0, doc1, doc2, doc3, doc4

        public static void Execute() {
            String API_KEY = "your api key";
            String API_URL = "https://sandbox.esignlive.com/api";
            EslClient eslClient = new EslClient(API_KEY, API_URL);
            String packageId = "pv_KQJiojk9yLaJU1cxqLuV4kSs="; //template ID
            String roleID = "9624914d-64f0-44a3-975b-89cb4a3c9073";

            DocumentPackage template = eslClient.GetPackage(new PackageId(packageId));
            List<string> documentList = new List<string>();
            documentList.Add("doc0");
            documentList.Add("doc1");
            documentList.Add("doc2");
            documentList.Add("doc3");
            documentList.Add("doc4");


            PackageBuilder pb = PackageBuilder.NewPackageNamed("package created from template "+ DateTime.Now.ToString("HH:mm:ss tt"))
                .WithSigner(SignerBuilder.NewSignerWithEmail("signer1@mailinator.com").WithCustomId(roleID).WithFirstName("1.firstname").WithLastName("1.lastname"));
            

            foreach (var curDoc in template.Documents)
            {
                if (documentList.Contains(curDoc.Name)) {
                    DocumentBuilder db = DocumentBuilder.NewDocumentNamed(curDoc.Name).WithId(curDoc.Id).EnableExtraction()
                        .FromFile("...\\6pages.pdf"); // you can write your own matching logic here

                    List<Signature> signatureList = curDoc.Signatures;
                    foreach (var signature in signatureList) {
                        //Debugger.Log(1, "Debug", signature.IsPlaceholderSignature() + "\n");
                                               
                        

                        db.WithSignature(signature);
                    }

                    //inject fields
                    db.WithInjectedField(FieldBuilder.TextField().WithName("").WithValue(""));
                    db.WithInjectedField(FieldBuilder.TextField().WithName("").WithValue(""));
                    db.WithInjectedField(FieldBuilder.TextField().WithName("").WithValue(""));
                    db.WithInjectedField(FieldBuilder.TextField().WithName("").WithValue(""));


                    pb.WithDocument(db);
                }
            }


            DocumentPackage package = pb.Build();
            PackageId packageID = eslClient.CreatePackageOneStep(package);
            eslClient.SendPackage(packageID);
            

        }


     


    }
}
